#version 150

#moj_import <fog.glsl>
#moj_import <discretize.glsl>
#moj_import <glint.glsl>

uniform sampler2D Sampler0;
uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform mat4 TextureMat;

in float vertexDistance;
in vec2 texCoord0;
in vec2 edgeUV;

out vec4 fragColor;

void main() {
    vec2 texCoord = discretize(texCoord0, vec2(64, 32));
    texCoord = (TextureMat * vec4(texCoord, 0, 1)).xy;
    vec4 color = texture(Sampler0, texCoord) * ColorModulator;

    color = floor(color * 8) / 8 * color/color;
    float edge = smoothstep(0.0, 1.0, edginess(edgeUV));
    color /= pow(edge, 4.0) * 7.0;

    float fade = linear_fog_fade(vertexDistance, FogStart, FogEnd);
    fragColor = vec4(color.rgb * fade, color.a);
}
